//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A7EC4DD0301.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A7EC4DD0301.cm

//## begin module%3A7EC4DD0301.cp preserve=no
//## end module%3A7EC4DD0301.cp

//## Module: FitStrategy%3A7EC4DD0301; Package specification
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /data/verisB/dorman/Xspec/src/XSFit/Fit/FitStrategy.h

#ifndef STRATEGY_H
#define STRATEGY_H 1

//## begin module%3A7EC4DD0301.additionalIncludes preserve=no
//## end module%3A7EC4DD0301.additionalIncludes

//## begin module%3A7EC4DD0301.includes preserve=yes
//## end module%3A7EC4DD0301.includes


class Fit;

//## begin module%3A7EC4DD0301.declarations preserve=no
//## end module%3A7EC4DD0301.declarations

//## begin module%3A7EC4DD0301.additionalDeclarations preserve=yes
//## end module%3A7EC4DD0301.additionalDeclarations


//## Class: FitStrategy%3A7EC3F502B5
//## Category: XSFit::Fit%36349D710188
//## Subsystem: XSFit::Fit%3677C9158350
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A7EC9BE00CD;Fit { -> F}

class FitStrategy 
{
  public:
    //## Constructors (generated)
      FitStrategy();

    //## Destructor (generated)
      virtual ~FitStrategy();


    //## Other Operations (specified)
      //## Operation: perform%3A7EC7ED0219
      //	apply the strategy to the fit data.
      //
      //	Template method instance: provide public interface in
      //	base class to private abstract methods.
      virtual void perform (Fit* fit);

  protected:

    //## Other Operations (specified)
      //## Operation: doPerform%3B7AAA2D0051
      virtual void doPerform (Fit* fit) = 0;

  private:
    //## Constructors (generated)
      FitStrategy(const FitStrategy &right);

    //## Assignment Operation (generated)
      FitStrategy & operator=(const FitStrategy &right);

  private: //## implementation
};

// Class FitStrategy 

//## begin module%3A7EC4DD0301.epilog preserve=yes
//## end module%3A7EC4DD0301.epilog


#endif
